--- ./bgpd/mrt.c.dist	Wed Jan 10 09:22:24 2007
+++ ./bgpd/mrt.c	Wed Jan 10 09:19:09 2007
@@ -16,6 +16,9 @@
  * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
+/* +4-Byte AS:   modifications for 4 Byte AS Number Support - 
+                 Geoff Huston, January 2007 */
+
 #include <sys/types.h>
 #include <sys/queue.h>
 
@@ -114,8 +117,9 @@
 		return (-1);
 	}
 
-	DUMP_SHORT(buf, bgp->as);
-	DUMP_SHORT(buf, peer->conf.remote_as);
+	/* +4-Byte AS:   as number is a LONG */ 
+	DUMP_LONG(buf, bgp->as);
+	DUMP_LONG(buf, peer->conf.remote_as);
 	DUMP_SHORT(buf, /* ifindex */ 0);
 	switch (peer->sa_local.ss_family) {
 	case AF_INET:
@@ -181,8 +185,9 @@
 		return (-1);
 	}
 
-	DUMP_SHORT(buf, bgp->as);
-	DUMP_SHORT(buf, peer->conf.remote_as);
+	/* +4-Byte AS:   as number is a LONG */ 
+	DUMP_LONG(buf, bgp->as);
+	DUMP_LONG(buf, peer->conf.remote_as);
 	DUMP_SHORT(buf, /* ifindex */ 0);
 	switch (peer->sa_local.ss_family) {
 	case AF_INET:
@@ -350,8 +355,9 @@
 		return (-1);
 	}
 
-	DUMP_SHORT(buf, rde_local_as());
-	DUMP_SHORT(buf, peer->conf.remote_as);
+	/* +4-Byte AS:   as number is a LONG */ 
+	DUMP_LONG(buf, rde_local_as());
+	DUMP_LONG(buf, peer->conf.remote_as);
 	DUMP_SHORT(buf, /* ifindex */ 0);
 
 	switch (af) {
